OGRE-Next: Ogre::v1::ManualObject Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | List of all members
Ogre::v1::ManualObject Class Reference
Core | Component » Scene

Class providing a much simplified interface to generating manual objects with custom geometry. More...

`#include <OgreManualObject.h>`

Inheritance diagram for Ogre::v1::ManualObject:
[legend]

## Classes
class | ManualObjectSection
| Built, renderable section of geometry. More...

## Public Types
typedef vector< ManualObjectSection * >::type | SectionList
Public Types inherited from Ogre::MovableObject
typedef FastArray< MovableObject * > | MovableObjectArray

## Public Member Functions
| ManualObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager)
| ~ManualObject () override
void | _releaseManualHardwareResources () override
| Notifies the movable object that hardware resources were lost.
void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
virtual void | begin (const String &materialName, OperationType opType=OT_TRIANGLE_LIST, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Start defining a part of the object.
virtual void | beginUpdate (size_t sectionIndex)
| Start the definition of an update to a part of the object.
virtual void | clear ()
| Completely clear the contents of the object.
virtual void | colour (const ColourValue &col)
| Add a vertex colour to a vertex.
virtual void | colour (Real r, Real g, Real b, Real a=1.0f)
| Add a vertex colour to a vertex.
virtual MeshPtr | convertToMesh (const String &meshName, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, bool buildShadowMapBuffers=true)
| Convert this object to a Mesh.
virtual ManualObjectSection * | end ()
| Finish defining the object and compile the final renderable version.
virtual void | estimateIndexCount (size_t icount)
| Estimate the number of indices ahead of time.
virtual void | estimateVertexCount (size_t vcount)
| Estimate the number of vertices ahead of time.
virtual size_t | getCurrentIndexCount () const
| Get the number of indices in the section currently being defined (returns 0 if no section is in progress).
virtual size_t | getCurrentVertexCount () const
| Get the number of vertices in the section currently being defined (returns 0 if no section is in progress).
virtual bool | getDynamic () const
| Gets whether this object is marked as dynamic.
EdgeData * | getEdgeList ()
| Implement this method to enable stencil shadows.
bool | getKeepDeclarationOrder () const
| Gets whether or not the declaration order is to be kept or not.
const String & | getMovableType () const override
| Returns the type name of this object.
unsigned int | getNumSections () const
| Retrieves the number of ManualObjectSection objects making up this ManualObject.
ManualObjectSection * | getSection (unsigned int index) const
| Gets a pointer to a ManualObjectSection, i.e.
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getWriteOnly () const
| Gets wheter this object has geometry buffer marked as write only.
bool | hasEdgeList ()
| Overridden member from ShadowCaster.
virtual void | index (uint32 idx)
| Add a vertex index to construct faces / lines / points via indexing rather than just by a simple list of vertices.
virtual void | normal (const Vector3 &norm)
| Add a vertex normal to the current vertex.
virtual void | normal (Real x, Real y, Real z)
| Add a vertex normal to the current vertex.
virtual void | position (const Vector3 &pos)
| Add a vertex position, starting a new vertex at the same time.
virtual void | position (Real x, Real y, Real z)
| Add a vertex position, starting a new vertex at the same time.
virtual void | quad (uint32 i1, uint32 i2, uint32 i3, uint32 i4)
| Add a set of 4 vertex indices to construct a quad (out of 2 triangles); this is a shortcut to calling index() 6 times, or triangle() twice.
virtual void | setDynamic (bool dyn)
| Use before defining geometry to indicate that you intend to update the geometry regularly and want the internal structure to reflect that.
void | setKeepDeclarationOrder (bool keepOrder)
| Sets whether or not to keep the original declaration order when queuing the renderables.
virtual void | setMaterialName (size_t subIndex, const String &name, const String &group=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Alter the material for a subsection of this object after it has been specified.
virtual void | setReadable (bool readable)
| Use before defining geometry to indicate that you intend to be able to read back from the geometry buffers again down the line (object convertion to v2, physics engine body creation...
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual void | setWriteOnly (bool writeOnly)
| Same as setReadable, but with the invese scemantic.
virtual void | tangent (const Vector3 &tan)
| Add a vertex tangent to the current vertex.
virtual void | tangent (Real x, Real y, Real z)
| Add a vertex tangent to the current vertex.
virtual void | textureCoord (const Vector2 &uv)
| Add a texture coordinate to the current vertex.
virtual void | textureCoord (const Vector3 &uvw)
| Add a texture coordinate to the current vertex.
virtual void | textureCoord (const Vector4 &xyzw)
| Add a texture coordinate to the current vertex.
virtual void | textureCoord (Real u)
| Add a texture coordinate to the current vertex.
virtual void | textureCoord (Real u, Real v)
| Add a texture coordinate to the current vertex.
virtual void | textureCoord (Real u, Real v, Real w)
| Add a texture coordinate to the current vertex.
virtual void | textureCoord (Real x, Real y, Real z, Real w)
| Add a texture coordinate to the current vertex.
virtual void | triangle (uint32 i1, uint32 i2, uint32 i3)
| Add a set of 3 vertex indices to construct a triangle; this is a shortcut to calling index() 3 times.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, uint8 renderQueueId)
| Constructor.
| MovableObject (ObjectData *objectDataPtrs)
| Don't use this constructor unless you know what you're doing.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager () const
| Get the manager of this object, if any (internal use only)
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state.
const Matrix4 & | _getParentNodeFullTransform () const
| Returns the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node.
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only)
virtual void | _notifyParentNodeMemoryChanged ()
virtual void | _notifyStaticDirty () const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent ()
| Detaches an object from a parent SceneNode if attached.
RealAsUint | getCachedDistanceToCamera () const
| Returns the distance to camera as calculated in cullFrustum()
Real | getCachedDistanceToCameraAsReal () const
| Returns the distance to camera as calculated in cullFrustum()
bool | getCastShadows () const
| Returns whether shadow casting is enabled for this object.
unsigned char | getCurrentMeshLod () const
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener () const
| Gets the current listener for this object.
Aabb | getLocalAabb () const
| Retrieves the local axis-aligned bounding box for this object.
float | getLocalRadius () const
| See getLocalAabb and getWorldRadius.
const String & | getName () const
| Returns the name of this object.
Node * | getParentNode () const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode () const
uint32 | getQueryFlags () const
| Returns the query flags relevant for this object.
Real | getRenderingDistance () const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup () const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
Real | getShadowRenderingDistance () const
| Gets the distance at which batches are no longer casting shadows.
SkeletonInstance * | getSkeletonInstance () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
uint32 | getVisibilityFlags () const
| Returns the visibility flags relevant for this object.
bool | getVisible () const
| Gets this object whether to be visible or not, if it has a renderable component.
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space.
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space.
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
bool | isAttached () const
| Returns true if this object is attached to a Node.
bool | isStatic () const
| Checks whether this MovableObject is static.
bool | isVisible () const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights () const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object.
void | setName (const String &name)
| Sets a custom name for this node.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows.
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic.
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
const StringVector & | getAnimableValueNames () const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| See SceneManager::cullLights & see MovableObject::cullFrustum.
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static void | updateAllBounds (const size_t numNodes, ObjectData t)
Public Attributes inherited from Ogre::MovableObject
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
RenderableArray | mRenderables
Static Public Attributes inherited from Ogre::MovableObject
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

Class providing a much simplified interface to generating manual objects with custom geometry.

Remarks
  Building one-off geometry objects manually usually requires getting down and dirty with the vertex buffer and vertex declaration API, which some people find a steep learning curve. This class gives you a simpler interface specifically for the purpose of building a 3D object simply and quickly. Note that if you intend to instance your object you will still need to become familiar with the Mesh class.

  This class draws heavily on the interface for OpenGL immediate-mode (glBegin, glVertex, glNormal etc), since this is generally well-liked by people. There are a couple of differences in the results though - internally this class still builds hardware buffers which can be re-used, so you can render the resulting object multiple times without re-issuing all the same commands again. Secondly, the rendering is not immediate, it is still queued just like all OGRE objects. This makes this object more efficient than the equivalent GL immediate-mode commands, so it's feasible to use it for large objects if you really want to.

  To construct some geometry with this object:
  1. If you know roughly how many vertices (and indices, if you use them) you're going to submit, call estimateVertexCount and estimateIndexCount. This is not essential but will make the process more efficient by saving memory reallocations.
  2. Call begin() to begin entering data
  3. For each vertex, call position(), normal(), textureCoord(), colour() to define your vertex data. Note that each time you call position() you start a new vertex. Note that the first vertex defines the components of the vertex - you can't add more after that. For example if you didn't call normal() in the first vertex, you cannot call it in any others. You ought to call the same combination of methods per vertex.
  4. If you want to define triangles (or lines/points) by indexing into the vertex list, you can call index() as many times as you need to define them. If you don't do this, the class will assume you want triangles drawn directly as defined by the vertex list, i.e. non-indexed geometry. Note that stencil shadows are only supported on indexed geometry, and that indexed geometry is a little faster; so you should try to use it.
  5. Call end() to finish entering data.
  6. Optionally repeat the begin-end cycle if you want more geometry using different rendering operation types, or different materials After calling end(), the class will organise the data for that section internally and make it ready to render with. Like any other MovableObject you should attach the object to a SceneNode to make it visible. Other aspects like the relative render order can be controlled using standard MovableObject methods like setRenderQueueGroup.

  You can also use beginUpdate() to alter the geometry later on if you wish. If you do this, you should call setDynamic(true) before your first call to begin(), and also consider using estimateVertexCount / estimateIndexCount if your geometry is going to be growing, to avoid buffer recreation during growth.

  Note that like all OGRE geometry, triangles should be specified in anti-clockwise winding order (whether you're doing it with just vertices, or using indexes too). That is to say that the front of the face is the one where the vertices are listed in anti-clockwise order.

## Member Typedef Documentation

## ◆ SectionList

typedef vector<ManualObjectSection*>::type Ogre::v1::ManualObject::SectionList

## Constructor & Destructor Documentation

## ◆ ManualObject()

Ogre::v1::ManualObject::ManualObject | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager )

Referenced by Ogre::v1::ManualObject::ManualObjectSection::ManualObjectSection().

## ◆ ~ManualObject()

Ogre::v1::ManualObject::~ManualObject | ( |  | ) |
| override

## Member Function Documentation

## ◆ _releaseManualHardwareResources()

void Ogre::v1::ManualObject::_releaseManualHardwareResources | ( |  | ) |
| inlineoverridevirtual

Notifies the movable object that hardware resources were lost.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented from Ogre::MovableObject.

References clear().

## ◆ _updateRenderQueue()

void Ogre::v1::ManualObject::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera )
| overridevirtual

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

Remarks
  The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Reimplemented from Ogre::MovableObject.

## ◆ begin()

virtual void Ogre::v1::ManualObject::begin | ( | const String & | materialName,
|  | OperationType | opType = OT_TRIANGLE_LIST,
|  | const String & | groupName = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME )
| virtual

Start defining a part of the object.

Remarks
  Each time you call this method, you start a new section of the object with its own material and potentially its own type of rendering operation (triangles, points or lines for example).

Parameters

  materialName | The name of the material to render this part of the object with.
  opType | The type of operation to use to render.

References Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, and Ogre::OT_TRIANGLE_LIST.

## ◆ beginUpdate()

virtual void Ogre::v1::ManualObject::beginUpdate | ( | size_t | sectionIndex | ) |
| virtual

Start the definition of an update to a part of the object.

Remarks
  Using this method, you can update an existing section of the object efficiently. You do not have the option of changing the operation type obviously, since it must match the one that was used before.

Note
  If your sections are changing size, particularly growing, use estimateVertexCount and estimateIndexCount to pre-size the buffers a little larger than the initial needs to avoid buffer reconstruction.

Parameters

  sectionIndex | The index of the section you want to update. The first call to begin() would have created section 0, the second section 1, etc.

## ◆ clear()

virtual void Ogre::v1::ManualObject::clear | ( |  | ) |
| virtual

Completely clear the contents of the object.

Remarks
  Clearing the contents of this object and rebuilding from scratch is not the optimal way to manage dynamic vertex data, since the buffers are recreated. If you want to keep the same structure but update the content within that structure, use beginUpdate() instead of clear() begin(). However if you do want to modify the structure from time to time you can do so by clearing and re-specifying the data.

Referenced by _releaseManualHardwareResources().

## ◆ colour() [1/2]

virtual void Ogre::v1::ManualObject::colour | ( | const ColourValue & | col | ) |
| virtual

Add a vertex colour to a vertex.

## ◆ colour() [2/2]

virtual void Ogre::v1::ManualObject::colour | ( | Real | r,
|  | Real | g,
|  | Real | b,
|  | Real | a = 1.0f )
| virtual

Add a vertex colour to a vertex.

Parameters

  r,g,b,a | Colour components expressed as floating point numbers from 0-1

## ◆ convertToMesh()

virtual MeshPtr Ogre::v1::ManualObject::convertToMesh | ( | const String & | meshName,
|  | const String & | groupName = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME,
|  | bool | buildShadowMapBuffers = true )
| virtual

Convert this object to a Mesh.

Remarks
  After you've finished building this object, you may convert it to a Mesh if you want in order to be able to create many instances of it in the world (via Entity). This is optional, since this instance can be directly attached to a SceneNode itself, but of course only one instance of it can exist that way.

Note
  Only objects which use indexed geometry may be converted to a mesh.

Parameters

  meshName | The name to give the mesh
  groupName | The resource group to create the mesh in
  buildShadowMapBuffers | True to create an optimized copy of the vertex buffers for efficient shadow mapping.

References Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME.

## ◆ end()

virtual ManualObjectSection * Ogre::v1::ManualObject::end | ( |  | ) |
| virtual

Finish defining the object and compile the final renderable version.

Note
  Will return a pointer to the finished section or NULL if the section was discarded (i.e. has zero vertices/indices).

## ◆ estimateIndexCount()

virtual void Ogre::v1::ManualObject::estimateIndexCount | ( | size_t | icount | ) |
| virtual

Estimate the number of indices ahead of time.

Remarks
  Calling this helps to avoid memory reallocation when you define indices. Also very handy when using beginUpdate() to manage dynamic data - you can make the index buffer a little larger than the initial need to allow for growth later with this method.

## ◆ estimateVertexCount()

virtual void Ogre::v1::ManualObject::estimateVertexCount | ( | size_t | vcount | ) |
| virtual

Estimate the number of vertices ahead of time.

Remarks
  Calling this helps to avoid memory reallocation when you define vertices. Also very handy when using beginUpdate() to manage dynamic data - you can make the vertex buffers a little larger than their initial needs to allow for growth later with this method.

## ◆ getCurrentIndexCount()

virtual size_t Ogre::v1::ManualObject::getCurrentIndexCount | ( |  | ) | const
| virtual

Get the number of indices in the section currently being defined (returns 0 if no section is in progress).

## ◆ getCurrentVertexCount()

virtual size_t Ogre::v1::ManualObject::getCurrentVertexCount | ( |  | ) | const
| virtual

Get the number of vertices in the section currently being defined (returns 0 if no section is in progress).

## ◆ getDynamic()

virtual bool Ogre::v1::ManualObject::getDynamic | ( |  | ) | const
| inlinevirtual

Gets whether this object is marked as dynamic.

## ◆ getEdgeList()

EdgeData * Ogre::v1::ManualObject::getEdgeList | ( |  | ) |

Implement this method to enable stencil shadows.

## ◆ getKeepDeclarationOrder()

bool Ogre::v1::ManualObject::getKeepDeclarationOrder | ( |  | ) | const
| inline

Gets whether or not the declaration order is to be kept or not.

Returns
  A flag indication if the declaration order will be kept when queuing the renderables.

## ◆ getMovableType()

const String & Ogre::v1::ManualObject::getMovableType | ( |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ getNumSections()

unsigned int Ogre::v1::ManualObject::getNumSections | ( |  | ) | const

Retrieves the number of ManualObjectSection objects making up this ManualObject.

## ◆ getSection()

ManualObjectSection * Ogre::v1::ManualObject::getSection | ( | unsigned int | index | ) | const

Gets a pointer to a ManualObjectSection, i.e.

a part of a ManualObject.

References index().

## ◆ getUseIdentityProjection()

bool Ogre::v1::ManualObject::getUseIdentityProjection | ( |  | ) | const
| inline

Returns whether or not to use an 'identity' projection.

Remarks
  Usually ManualObjects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normally you don't need to change this.

See also
  ManualObject::setUseIdentityProjection

## ◆ getUseIdentityView()

bool Ogre::v1::ManualObject::getUseIdentityView | ( |  | ) | const
| inline

Returns whether or not to use an 'identity' view.

Remarks
  Usually ManualObjects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normally you don't need to change this.

See also
  ManualObject::setUseIdentityView

## ◆ getWriteOnly()

virtual bool Ogre::v1::ManualObject::getWriteOnly | ( |  | ) | const
| inlinevirtual

Gets wheter this object has geometry buffer marked as write only.

## ◆ hasEdgeList()

bool Ogre::v1::ManualObject::hasEdgeList | ( |  | ) |

Overridden member from ShadowCaster.

## ◆ index()

virtual void Ogre::v1::ManualObject::index | ( | uint32 | idx | ) |
| virtual

Add a vertex index to construct faces / lines / points via indexing rather than just by a simple list of vertices.

Remarks
  You will have to call this 3 times for each face for a triangle list, or use the alternative 3-parameter version. Other operation types require different numbers of indexes,

See also
  OperationType.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  idx | A vertex index from 0 to 4294967295.

Referenced by getSection().

## ◆ normal() [1/2]

virtual void Ogre::v1::ManualObject::normal | ( | const Vector3 & | norm | ) |
| virtual

Add a vertex normal to the current vertex.

Remarks
  Vertex normals are most often used for dynamic lighting, and their components should be normalised.

## ◆ normal() [2/2]

virtual void Ogre::v1::ManualObject::normal | ( | Real | x,
|  | Real | y,
|  | Real | z )
| virtual

Add a vertex normal to the current vertex.

Remarks
  Vertex normals are most often used for dynamic lighting, and their components should be normalised.

## ◆ position() [1/2]

virtual void Ogre::v1::ManualObject::position | ( | const Vector3 & | pos | ) |
| virtual

Add a vertex position, starting a new vertex at the same time.

Remarks
  A vertex position is slightly special among the other vertex data methods like normal() and textureCoord(), since calling it indicates the start of a new vertex. All other vertex data methods you call after this are assumed to be adding more information (like normals or texture coordinates) to the last vertex started with position().

## ◆ position() [2/2]

virtual void Ogre::v1::ManualObject::position | ( | Real | x,
|  | Real | y,
|  | Real | z )
| virtual

Add a vertex position, starting a new vertex at the same time.

Remarks
  A vertex position is slightly special among the other vertex data methods like normal() and textureCoord(), since calling it indicates the start of a new vertex. All other vertex data methods you call after this are assumed to be adding more information (like normals or texture coordinates) to the last vertex started with position().

## ◆ quad()

virtual void Ogre::v1::ManualObject::quad | ( | uint32 | i1,
|  | uint32 | i2,
|  | uint32 | i3,
|  | uint32 | i4 )
| virtual

Add a set of 4 vertex indices to construct a quad (out of 2 triangles); this is a shortcut to calling index() 6 times, or triangle() twice.

It's only valid for triangle list operations.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  i1,i2,i3,i4 | 4 vertex indices from 0 to 4294967295 defining a quad.

## ◆ setDynamic()

virtual void Ogre::v1::ManualObject::setDynamic | ( | bool | dyn | ) |
| inlinevirtual

Use before defining geometry to indicate that you intend to update the geometry regularly and want the internal structure to reflect that.

## ◆ setKeepDeclarationOrder()

void Ogre::v1::ManualObject::setKeepDeclarationOrder | ( | bool | keepOrder | ) |
| inline

Sets whether or not to keep the original declaration order when queuing the renderables.

Remarks
  This overrides the default behavior of the rendering queue, specifically stating the desired order of rendering. Might result in a performance loss, but lets the user to have more direct control when creating geometry through this class.

Parameters

  keepOrder | Whether to keep the declaration order or not.

## ◆ setMaterialName()

virtual void Ogre::v1::ManualObject::setMaterialName | ( | size_t | subIndex,
|  | const String & | name,
|  | const String & | group = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME )
| virtual

Alter the material for a subsection of this object after it has been specified.

Remarks
  You specify the material to use on a section of this object during the call to begin(), however if you want to change the material afterwards you can do so by calling this method.

Parameters

  subIndex | The index of the subsection to alter
  name | The name of the new material to use

References Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME.

## ◆ setReadable()

virtual void Ogre::v1::ManualObject::setReadable | ( | bool | readable | ) |
| inlinevirtual

Use before defining geometry to indicate that you intend to be able to read back from the geometry buffers again down the line (object convertion to v2, physics engine body creation...

Referenced by setWriteOnly().

## ◆ setUseIdentityProjection()

void Ogre::v1::ManualObject::setUseIdentityProjection | ( | bool | useIdentityProjection | ) |

Sets whether or not to use an 'identity' projection.

Remarks
  Usually ManualObjects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normally you don't need to change this. The default is false.

See also
  ManualObject::getUseIdentityProjection

## ◆ setUseIdentityView()

void Ogre::v1::ManualObject::setUseIdentityView | ( | bool | useIdentityView | ) |

Sets whether or not to use an 'identity' view.

Remarks
  Usually ManualObjects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normally you don't need to change this. The default is false.

See also
  ManualObject::getUseIdentityView

## ◆ setWriteOnly()

virtual void Ogre::v1::ManualObject::setWriteOnly | ( | bool | writeOnly | ) |
| inlinevirtual

Same as setReadable, but with the invese scemantic.

References setReadable().

## ◆ tangent() [1/2]

virtual void Ogre::v1::ManualObject::tangent | ( | const Vector3 & | tan | ) |
| virtual

Add a vertex tangent to the current vertex.

Remarks
  Vertex tangents are most often used for dynamic lighting, and their components should be normalised. Also, using tangent() you enable VES_TANGENT vertex semantic, which is not supported on old non-SM2 cards.

## ◆ tangent() [2/2]

virtual void Ogre::v1::ManualObject::tangent | ( | Real | x,
|  | Real | y,
|  | Real | z )
| virtual

Add a vertex tangent to the current vertex.

Remarks
  Vertex tangents are most often used for dynamic lighting, and their components should be normalised. Also, using tangent() you enable VES_TANGENT vertex semantic, which is not supported on old non-SM2 cards.

## ◆ textureCoord() [1/7]

virtual void Ogre::v1::ManualObject::textureCoord | ( | const Vector2 & | uv | ) |
| virtual

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [2/7]

virtual void Ogre::v1::ManualObject::textureCoord | ( | const Vector3 & | uvw | ) |
| virtual

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [3/7]

virtual void Ogre::v1::ManualObject::textureCoord | ( | const Vector4 & | xyzw | ) |
| virtual

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [4/7]

virtual void Ogre::v1::ManualObject::textureCoord | ( | Real | u | ) |
| virtual

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [5/7]

virtual void Ogre::v1::ManualObject::textureCoord | ( | Real | u,
|  | Real | v )
| virtual

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [6/7]

virtual void Ogre::v1::ManualObject::textureCoord | ( | Real | u,
|  | Real | v,
|  | Real | w )
| virtual

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [7/7]

virtual void Ogre::v1::ManualObject::textureCoord | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | Real | w )
| virtual

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ triangle()

virtual void Ogre::v1::ManualObject::triangle | ( | uint32 | i1,
|  | uint32 | i2,
|  | uint32 | i3 )
| virtual

Add a set of 3 vertex indices to construct a triangle; this is a shortcut to calling index() 3 times.

It is only valid for triangle lists.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  i1,i2,i3 | 3 vertex indices from 0 to 4294967295 defining a face.

The documentation for this class was generated from the following file:

- OgreManualObject.h